unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

const
  URLWSAA = 'https://wsaahomo.afip.gov.ar/ws/services/LoginCms';
  URLWSW = 'https://wswhomo.afip.gov.ar/wsfev1/service.asmx';

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Button17: TButton;
    Button18: TButton;
    Button16: TButton;
    Button15: TButton;
    Label2: TLabel;
    Button19: TButton;
    Button20: TButton;
    procedure Button17Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button19Click(Sender: TObject);
    procedure Button20Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  FEAFIPLib_TLB;

{$R *.dfm}

procedure TForm1.Button17Click(Sender: TObject);
var
  lwsfev1: Iwsfev1;
  nro: Double;
  CAE, Vencimiento, Resultado: Widestring;
  PtoVta, TipoComp: Integer;
begin
  PtoVta := 2000; // Un Punto de Venta dado de alta en la AFIP;
  TipoComp := 206; // Factura A(Ver excel referencias codigos AFIP documentacion.rar)

  lwsfev1 := Cowsfev1.Create;
  lwsfev1.CUIT := 20939802593;
  lwsfev1.URL := URLWSW;

  lwsfev1.Depurar := true;
  If lwsfev1.login('certificado.crt', 'clave.key', URLWSAA) Then
  begin
      If Not lwsfev1.RecuperaLastCMP(PtoVta, TipoComp, nro) Then
      begin
          ShowMessage (lwsfev1.ErrorDesc);
          Exit;
      end;
      Nro := nro + 1;

      lwsfev1.AgregaFactura(1, 80, 30504507323, nro, nro,
        FormatDateTime('yyyymmdd', now), 3630000, 0, 3000000, 0,
        '', '', FormatDateTime('yyyymmdd', now + 30), 'PES', 1);
      lwsfev1.AgregaIVA(5, 3000000, 630000); // IVA 21
      lwsfev1.AgregaOpcional('2101', '0150507801000124703453');
      lwsfev1.AgregaCompAsoc(91, PtoVta, 102, 20939802593, '20190203');
      If lwsfev1.Autorizar(PtoVta, TipoComp) Then
      begin
        if lwsfev1.SFResultado[0] = 'A' then
          Showmessage('Felicitaciones! CAE y Vencimiento: ' +
            lwsfev1.SFCAE[0] + '/' + lwsfev1.SFVencimiento[0])
        else
          Showmessage(lwsfev1.AutorizarRespuestaObs(0));
      end
      else
        ShowMessage(lwsfev1.ErrorDesc);
  end
  else
      ShowMessage(lwsfev1.ErrorDesc);
end;

procedure TForm1.Button18Click(Sender: TObject);
var
  fceObj: Iwsfecred;
  rolCUITRepresentada: WideString;
  CUITContraparte: Double;
  codTipoCmp: Integer;
  estadoCmp: WideString;
  fecha_tipo: WideString;
  fechaDesde: WideString;
  fecha_hasta: WideString;
  codCtaCte: Double;
  estadoCtaCte: WideString;
  consultarComprobantesReturn: IConsultarCmpReturnTy;
begin
  rolCUITRepresentada := 'EMISOR';
  CUITContraparte := 0;
  codTipoCmp := 0;
  estadoCmp := '';
  fecha_tipo := '';
  fechaDesde := '';
  fecha_hasta := '';
  codCtaCte := 0;
  estadoCtaCte := '';

  fceObj := Cowsfecred.Create;
  fceObj.CUIT := 20939802593;
  fceObj.modoProduccion := false;
  fceObj.Depurar := true;
  If fceObj.login('certificado.crt', 'clave.key') Then
  begin
    if fceObj.consultarComprobantes(rolCUITRepresentada,
      CUITContraparte, codTipoCmp, estadoCmp, fecha_tipo, fechaDesde, fecha_hasta,
      codCtaCte, estadoCtaCte) then
    begin
      consultarComprobantesReturn := fceObj.consultarCmpReturn;
      ShowMessage('Consulta realizada con xito. Cantidad de comprobantes: ' + IntToStr(consultarComprobantesReturn.arrayComprobantesCount));
    end
    else
      ShowMessage(fceObj.errorDesc);
  end
  else
    ShowMessage(fceObj.ErrorDesc);
end;

procedure TForm1.Button16Click(Sender: TObject);
var
  fceObj: Iwsfecred;
  informarFECred: IInformarFacturaAgtDptoCltvRequestTy;
  codCtaCte: Integer;
  CUITEmisor: Int64;
  codTipoCmp: Integer;
  ptoVta: Integer;
  nroCmp: Integer;
  cuentaDepositante: Integer;
  subcuentaComitente: Double;
  denominacion: WideString;
begin
  codCtaCte := 1;
  CUITEmisor := 27929007862;
  codTipoCmp := 201;
  ptoVta := 10;
  nroCmp := 1;

  fceObj := Cowsfecred.Create;
  fceObj.CUIT := 20939802593;
  fceObj.modoProduccion := false;
  fceObj.Depurar := true;
  If fceObj.login('certificado.crt', 'clave.key') Then
  begin
    informarFECred := fceObj.nuevoInformarFacturaAgtDptoCltvRequestTy;
    //Usar una de las dos opciones de abajo para identificar. idCtaCte o idfactura
    //informarFECred.idCtaCte(codCtaCte);
    informarFECred.idFactura(
      CUITEmisor,
      codTipoCmp,
      ptoVta,
      nroCmp);
    cuentaDepositante := 250;
    subcuentaComitente := 120310;
    denominacion := 'denominacion';
    informarFECred.ctaComitente(cuentaDepositante, subcuentaComitente, denominacion);
    if fceObj.informarFacturaAgtDptoCltv(informarFECred) then
      ShowMessage('Operacin realizada con xito')
    else
      ShowMessage(fceObj.errorDesc);
  end
  else
    ShowMessage(fceObj.ErrorDesc);
end;

procedure TForm1.Button15Click(Sender: TObject);
var
  fceObj: Iwsfecred;
  aceptarFECred: IAceptarFECredRequestTy;
  codCtaCte: Double;
  CUITEmisor: Double;
  codTipoCmp: Integer;
  ptoVta: Integer;
  nroCmp: Double;
  cacepta: Boolean;
  cCUITEmisor: Int64;
  ccodTipoCmp: Integer;
  cptoVta: Integer;
  cnroCmp: Integer;
  codigoCancelacion: Integer;
  descripcionCancelacion: string;
  rcodTipo: Integer;
  rimporte: double;
  rporcentaje: double;
  rdescMotivo: string;
  acodigo: Integer;
  aimporte: double;
begin
  codCtaCte := 1;
  CUITEmisor := 27929007862;
  codTipoCmp := 201;
  ptoVta := 10;
  nroCmp := 1;

  fceObj := Cowsfecred.Create;
  fceObj.CUIT := 20939802593;
  fceObj.modoProduccion := false;
  fceObj.Depurar := true;
  If fceObj.login('certificado.crt', 'clave.key') Then
  begin
    aceptarFECred := fceObj.nuevoAceptarFECredRequestTy;

    //Usar una de las dos opciones de abajo para identificar. idCtaCte o idfactura
    //aceptarFECred.idCtaCte(codCtaCte);
    aceptarFECred.idFactura(
      CUITEmisor,
      codTipoCmp,
      ptoVta,
      nroCmp);
    aceptarFECred.tipoCancelacion := 'TOT';
    aceptarFECred.importeCancelado := 10.1;
    aceptarFECred.importeTotalRetPesos := 11.2;
    aceptarFECred.importeEmbargoPesos := 12.4;
    aceptarFECred.saldoAceptado := 13.6;
    aceptarFECred.codMoneda := 'PES';
    aceptarFECred.cotizacionMonedaUlt := 1.2;

    //Confirmar Notas 1..N
    cacepta := true;
    cCUITEmisor := 27929007862;
    ccodTipoCmp := 201;
    cptoVta := 10;
    cnroCmp := 1;

    aceptarFECred.arrayConfirmarNotasDC(
      cacepta, cCUITEmisor, ccodTipoCmp, cptoVta, cnroCmp);

    //Formas de cancelacion 1..N
    codigoCancelacion := 1;
    descripcionCancelacion := 'descripcionCancelacion';
    aceptarFECred.arrayFormasCancelacion(codigoCancelacion, descripcionCancelacion);

    //Retenciones 1..N
    rcodTipo := 1;
    rimporte := 10.3;
    rporcentaje := 5.5;
    rdescMotivo := 'Motivo 2';
    aceptarFECred.arrayRetenciones(rcodTipo, rimporte, rporcentaje, rdescMotivo);
    rcodTipo := 1;
    rimporte := 0.9;
    rporcentaje := 0.0;
    rdescMotivo := 'Motivo 2';
    aceptarFECred.arrayRetenciones(rcodTipo, rimporte, rporcentaje, rdescMotivo);

    //Ajustes 1..N
    acodigo := 1;
    aimporte := 10.3;
    aceptarFECred.arrayAjustesOperacion(acodigo, aimporte);

    if fceObj.aceptarFECred(aceptarFECred) then
      ShowMessage('Operacin realizada con xito')
    else
      ShowMessage(fceObj.errorDesc);
  end
  else
    ShowMessage(fceObj.ErrorDesc);

end;

procedure TForm1.Button19Click(Sender: TObject);
var
  fceObj: Iwsfecred;
  rechazarFECred: IRechazarFECredRequestTy;
  CUITEmisor: Int64;
  codTipoCmp: Integer;
  ptoVta: Integer;
  nroCmp: Integer;
  codMotivo: Integer;
  descMotivo: string;
  justificacion: string;
begin
  CUITEmisor := 27929007862;
  codTipoCmp := 201;
  ptoVta := 10;
  nroCmp := 1;

  fceObj := Cowsfecred.Create;
  fceObj.CUIT := 20939802593;
  fceObj.modoProduccion := false;
  fceObj.Depurar := true;
  If fceObj.login('certificado.crt', 'clave.key') Then
  begin
    rechazarFECred := fceObj.nuevoRechazarFECredRequestTy;

    //Usar una de las dos opciones de abajo para identificar. idCtaCte o idfactura
    //aceptarFECred.idCtaCte(codCtaCte);
    rechazarFECred.idFactura(
      CUITEmisor,
      codTipoCmp,
      ptoVta,
      nroCmp);

    codMotivo := 1;
    descMotivo := 'Mercaderia daada';
    justificacion := 'Accidente vial';

    rechazarFECred.arrayMotivosRechazo(codMotivo, descMotivo, justificacion);
    if fceObj.rechazarFECred(rechazarFECred) then
      ShowMessage('Operacin realizada con xito')
    else
      ShowMessage(fceObj.errorDesc);
  end
  else
    ShowMessage(fceObj.ErrorDesc);
end;

procedure TForm1.Button20Click(Sender: TObject);
var
  fceObj: Iwsfecred;
  rolCUITRepresentada: WideString;
  CUITContraparte: Double;
  codTipoCmp: Integer;
  estadoCmp: WideString;
  fecha_tipo: WideString;
  fechaDesde: WideString;
  fecha_hasta: WideString;
  codCtaCte: Double;
  estadoCtaCte: WideString;
  consultarComprobantesReturn: IConsultarCmpReturnTy;
begin
  rolCUITRepresentada := 'RECEPTOR';
  CUITContraparte := 0;
  codTipoCmp := 0;
  estadoCmp := '';
  fecha_tipo := '';
  fechaDesde := '';
  fecha_hasta := '';
  codCtaCte := 0;
  estadoCtaCte := '';

  fceObj := Cowsfecred.Create;
  fceObj.CUIT := 30504507323;
  fceObj.modoProduccion := false;
  fceObj.Depurar := true;
  If fceObj.login('certificado.crt', 'clave.key') Then
  begin
    if fceObj.consultarComprobantes(rolCUITRepresentada,
      CUITContraparte, codTipoCmp, estadoCmp, fecha_tipo, fechaDesde, fecha_hasta,
      codCtaCte, estadoCtaCte) then
    begin
      consultarComprobantesReturn := fceObj.consultarCmpReturn;
      ShowMessage('Consulta realizada con xito. Cantidad de comprobantes: ' + IntToStr(consultarComprobantesReturn.arrayComprobantesCount));
    end
    else
      ShowMessage(fceObj.errorDesc);
  end
  else
    ShowMessage(fceObj.ErrorDesc);
end;

end.
